Index: squid/src/auth/ntlm/helpers/winbind/wb_common.c
diff -u /dev/null squid/src/auth/ntlm/helpers/winbind/wb_common.c:1.3.10.1
--- /dev/null	Mon Jan 26 04:57:41 2004
+++ squid/src/auth/ntlm/helpers/winbind/wb_common.c	Tue Sep  3 10:42:44 2002
@@ -0,0 +1,403 @@
+/* 
+   Unix SMB/Netbios implementation.
+   Version 2.0
+
+   winbind client common code
+
+   Copyright (C) Tim Potter 2000
+   Copyright (C) Andrew Tridgell 2000
+   
+   This library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Library General Public
+   License as published by the Free Software Foundation; either
+   version 2 of the License, or (at your option) any later version.
+   
+   This library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Library General Public License for more details.
+   
+   You should have received a copy of the GNU Library General Public
+   License along with this library; if not, write to the
+   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+   Boston, MA  02111-1307, USA.   
+*/
+
+#include "winbind_nss_config.h"
+#include "winbindd_nss.h"
+#include "config.h"
+
+
+/* Global variables.  These are effectively the client state information */
+
+int winbindd_fd = -1;		/* fd for winbindd socket */
+static char *excluded_domain;
+
+/* Free a response structure */
+
+void
+free_response(struct winbindd_response *response)
+{
+    /* Free any allocated extra_data */
+
+    if (response)
+	SAFE_FREE(response->extra_data);
+}
+
+/*
+  smbd needs to be able to exclude lookups for its own domain
+*/
+void
+winbind_exclude_domain(const char *domain)
+{
+    SAFE_FREE(excluded_domain);
+    excluded_domain = strdup(domain);
+}
+
+
+/* Initialise a request structure */
+
+void
+init_request(struct winbindd_request *request, int request_type)
+{
+    static char *domain_env;
+    static BOOL initialised;
+
+    request->length = sizeof(struct winbindd_request);
+
+    request->cmd = (enum winbindd_cmd) request_type;
+    request->pid = getpid();
+    request->domain[0] = '\0';
+
+    if (!initialised) {
+	initialised = True;
+	domain_env = getenv(WINBINDD_DOMAIN_ENV);
+    }
+
+    if (domain_env) {
+	strncpy(request->domain, domain_env, sizeof(request->domain) - 1);
+	request->domain[sizeof(request->domain) - 1] = '\0';
+    }
+}
+
+/* Initialise a response structure */
+
+void
+init_response(struct winbindd_response *response)
+{
+    /* Initialise return value */
+
+    response->result = WINBINDD_ERROR;
+}
+
+/* Close established socket */
+
+void
+close_sock(void)
+{
+    if (winbindd_fd != -1) {
+	close(winbindd_fd);
+	winbindd_fd = -1;
+    }
+}
+
+/* Connect to winbindd socket */
+
+int
+winbind_open_pipe_sock(void)
+{
+    struct sockaddr_un sunaddr;
+    static pid_t our_pid;
+    struct stat st;
+    pstring path;
+
+    if (our_pid != getpid()) {
+	close_sock();
+	our_pid = getpid();
+    }
+
+    if (winbindd_fd != -1) {
+	return winbindd_fd;
+    }
+
+    /* Check permissions on unix socket directory */
+
+    if (lstat(WINBINDD_SOCKET_DIR, &st) == -1) {
+	return -1;
+    }
+
+    if (!S_ISDIR(st.st_mode) || (st.st_uid != 0 && st.st_uid != geteuid())) {
+	return -1;
+    }
+
+    /* Connect to socket */
+
+    strncpy(path, WINBINDD_SOCKET_DIR, sizeof(path) - 1);
+    path[sizeof(path) - 1] = '\0';
+
+    strncat(path, "/", sizeof(path) - 1);
+    path[sizeof(path) - 1] = '\0';
+
+    strncat(path, WINBINDD_SOCKET_NAME, sizeof(path) - 1);
+    path[sizeof(path) - 1] = '\0';
+
+    ZERO_STRUCT(sunaddr);
+    sunaddr.sun_family = AF_UNIX;
+    strncpy(sunaddr.sun_path, path, sizeof(sunaddr.sun_path) - 1);
+
+    /* If socket file doesn't exist, don't bother trying to connect
+     * with retry.  This is an attempt to make the system usable when
+     * the winbindd daemon is not running. */
+
+    if (lstat(path, &st) == -1) {
+	return -1;
+    }
+
+    /* Check permissions on unix socket file */
+
+    if (!S_ISSOCK(st.st_mode) || (st.st_uid != 0 && st.st_uid != geteuid())) {
+	return -1;
+    }
+
+    /* Connect to socket */
+
+    if ((winbindd_fd = socket(AF_UNIX, SOCK_STREAM, 0)) == -1) {
+	return -1;
+    }
+
+    if (connect(winbindd_fd, (struct sockaddr *) &sunaddr,
+	    sizeof(sunaddr)) == -1) {
+	close_sock();
+	return -1;
+    }
+
+    return winbindd_fd;
+}
+
+/* Write data to winbindd socket with timeout */
+
+int
+write_sock(void *buffer, int count)
+{
+    int result, nwritten;
+
+    /* Open connection to winbind daemon */
+
+  restart:
+
+    if (winbind_open_pipe_sock() == -1) {
+	return -1;
+    }
+
+    /* Write data to socket */
+
+    nwritten = 0;
+
+    while (nwritten < count) {
+	struct timeval tv;
+	fd_set r_fds;
+
+	/* Catch pipe close on other end by checking if a read()
+	 * call would not block by calling select(). */
+
+	FD_ZERO(&r_fds);
+	FD_SET(winbindd_fd, &r_fds);
+	ZERO_STRUCT(tv);
+
+	if (select(winbindd_fd + 1, &r_fds, NULL, NULL, &tv) == -1) {
+	    close_sock();
+	    return -1;		/* Select error */
+	}
+
+	/* Write should be OK if fd not available for reading */
+
+	if (!FD_ISSET(winbindd_fd, &r_fds)) {
+
+	    /* Do the write */
+
+	    result = write(winbindd_fd,
+		(char *) buffer + nwritten, count - nwritten);
+
+	    if ((result == -1) || (result == 0)) {
+
+		/* Write failed */
+
+		close_sock();
+		return -1;
+	    }
+
+	    nwritten += result;
+
+	} else {
+
+	    /* Pipe has closed on remote end */
+
+	    close_sock();
+	    goto restart;
+	}
+    }
+
+    return nwritten;
+}
+
+/* Read data from winbindd socket with timeout */
+
+static int
+read_sock(void *buffer, int count)
+{
+    int result = 0, nread = 0;
+
+    /* Read data from socket */
+
+    while (nread < count) {
+
+	result = read(winbindd_fd, (char *) buffer + nread, count - nread);
+
+	if ((result == -1) || (result == 0)) {
+
+	    /* Read failed.  I think the only useful thing we
+	     * can do here is just return -1 and fail since the
+	     * transaction has failed half way through. */
+
+	    close_sock();
+	    return -1;
+	}
+
+	nread += result;
+    }
+
+    return result;
+}
+
+/* Read reply */
+
+int
+read_reply(struct winbindd_response *response)
+{
+    int result1, result2 = 0;
+
+    if (!response) {
+	return -1;
+    }
+
+    /* Read fixed length response */
+
+    if ((result1 = read_sock(response, sizeof(struct winbindd_response)))
+	== -1) {
+
+	return -1;
+    }
+
+    /* We actually send the pointer value of the extra_data field from
+     * the server.  This has no meaning in the client's address space
+     * so we clear it out. */
+
+    response->extra_data = NULL;
+
+    /* Read variable length response */
+
+    if (response->length > sizeof(struct winbindd_response)) {
+	int extra_data_len = response->length -
+	    sizeof(struct winbindd_response);
+
+	/* Mallocate memory for extra data */
+
+	if (!(response->extra_data = malloc(extra_data_len))) {
+	    return -1;
+	}
+
+	if ((result2 = read_sock(response->extra_data, extra_data_len))
+	    == -1) {
+	    free_response(response);
+	    return -1;
+	}
+    }
+
+    /* Return total amount of data read */
+
+    return result1 + result2;
+}
+
+/* 
+ * send simple types of requests 
+ */
+
+NSS_STATUS
+winbindd_send_request(int req_type, struct winbindd_request * request)
+{
+    struct winbindd_request lrequest;
+
+    /* Check for our tricky environment variable */
+
+    if (getenv(WINBINDD_DONT_ENV)) {
+	return NSS_STATUS_NOTFOUND;
+    }
+
+    /* smbd may have excluded this domain */
+    if (excluded_domain && strcasecmp(excluded_domain, request->domain) == 0) {
+	return NSS_STATUS_NOTFOUND;
+    }
+
+    if (!request) {
+	ZERO_STRUCT(lrequest);
+	request = &lrequest;
+    }
+
+    /* Fill in request and send down pipe */
+
+    init_request(request, req_type);
+
+    if (write_sock(request, sizeof(*request)) == -1) {
+	return NSS_STATUS_UNAVAIL;
+    }
+
+    return NSS_STATUS_SUCCESS;
+}
+
+/*
+ * Get results from winbindd request
+ */
+
+NSS_STATUS
+winbindd_get_response(struct winbindd_response * response)
+{
+    struct winbindd_response lresponse;
+
+    if (!response) {
+	ZERO_STRUCT(lresponse);
+	response = &lresponse;
+    }
+
+    init_response(response);
+
+    /* Wait for reply */
+    if (read_reply(response) == -1) {
+	return NSS_STATUS_UNAVAIL;
+    }
+
+    /* Throw away extra data if client didn't request it */
+    if (response == &lresponse) {
+	free_response(response);
+    }
+
+    /* Copy reply data from socket */
+    if (response->result != WINBINDD_OK) {
+	return NSS_STATUS_NOTFOUND;
+    }
+
+    return NSS_STATUS_SUCCESS;
+}
+
+/* Handle simple types of requests */
+
+NSS_STATUS
+winbindd_request(int req_type,
+    struct winbindd_request * request, struct winbindd_response * response)
+{
+    NSS_STATUS status;
+
+    status = winbindd_send_request(req_type, request);
+    if (status != NSS_STATUS_SUCCESS)
+	return (status);
+    return winbindd_get_response(response);
+}
Index: squid/src/auth/ntlm/helpers/winbind/wb_ntlm_auth.c
diff -u /dev/null squid/src/auth/ntlm/helpers/winbind/wb_ntlm_auth.c:1.3.10.1
--- /dev/null	Mon Jan 26 04:57:41 2004
+++ squid/src/auth/ntlm/helpers/winbind/wb_ntlm_auth.c	Tue Sep  3 10:42:44 2002
@@ -0,0 +1,425 @@
+/*
+ * (C) 2000 Francesco Chemolli <kinkie@kame.usr.dsi.unimi.it>
+ * (C) 2002 Andrew Bartlett <abartlet@samba.org>
+ *
+ * Distributed freely under the terms of the GNU General Public License,
+ * version 2. See the file COPYING for licensing details
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ *
+ */
+/*
+ * TODO:
+ * -add handling of the -d flag
+ * -move all squid-helper-protocol-related operations to helper functions
+ * -remove the hard-coded target NT domain name
+ *
+ * - MAYBE move squid-helper-protocol-related opetations to an external
+ *   library?
+ */
+
+
+#include "wbntlm.h"
+#include "util.h"
+/* stdio.h is included in wbntlm.h */
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+#include <sys/time.h>		/* for gettimeofday */
+#include <errno.h>		/* BUG: is this portable? */
+
+#ifdef HAVE_CTYPE_H
+#include <ctype.h>
+#endif
+
+#ifdef HAVE_UNISTD_H
+#include <unistd.h>
+#endif
+#if HAVE_GETOPT_H
+#include <getopt.h>
+#endif
+
+#include "winbind_nss_config.h"
+#include "winbindd_nss.h"
+
+#ifndef min
+#define min(x,y) ((x)<(y)?(x):(y))
+#endif
+
+void
+authfail(char *domain, char *user, char *reason)
+{
+    /* TODO: -move away from SEND-type gcc-isms
+     *       -prepare for protocol extension as soon as rbcollins is ready
+     */
+    SEND2("NA %s\\%s auth failure because: %s", domain, user, reason);
+}
+
+void
+authok(const char *domain, const char *user)
+{
+    SEND2("AF %s\\%s", domain, user);
+}
+
+void
+sendchallenge(const char *challenge)
+{
+    SEND2("TT %s", challenge);
+}
+
+void
+helperfail(const char *reason)
+{
+    SEND2("BH %s", reason);
+}
+
+char debug_enabled = 0;
+char *myname;
+pid_t mypid;
+
+static void
+lc(char *string)
+{
+    char *p = string, c;
+    while ((c = *p)) {
+	*p = tolower(c);
+	p++;
+    }
+}
+
+static void
+uc(char *string)
+{
+    char *p = string, c;
+    while ((c = *p)) {
+	*p = toupper(c);
+	p++;
+    }
+}
+
+
+
+NSS_STATUS winbindd_request(int req_type,
+    struct winbindd_request *request, struct winbindd_response *response);
+
+
+static tristate have_urandom = DONTKNOW;
+FILE *urandom_file = NULL;
+
+void
+init_random()
+{
+    if (have_urandom == DONTKNOW) {
+	int result = 0;
+	struct stat st;
+	result = stat(ENTROPY_SOURCE, &st);
+	if (result != 0 || !(S_ISCHR(st.st_mode) || S_ISBLK(st.st_mode))) {
+	    debug("Entropy source " ENTROPY_SOURCE " is unavailable\n");
+	    have_urandom = NO;
+	}
+	if ((urandom_file = fopen(ENTROPY_SOURCE, "r")) == NULL) {
+	    unsigned int seed;
+	    struct timeval t;
+	    warn("Can't open entropy source " ENTROPY_SOURCE "\n");
+	    have_urandom = NO;
+	    gettimeofday(&t, NULL);
+	    seed = squid_random() * getpid() * t.tv_sec * t.tv_usec;
+	    squid_srandom(seed);
+	} else {
+	    have_urandom = YES;
+	}
+    }
+}
+
+static unsigned char challenge[CHALLENGE_LEN + 1];
+static char *
+build_challenge(void)
+{
+    size_t gotchars;
+    unsigned char j;
+    switch (have_urandom) {
+    case YES:
+	if ((gotchars = fread(&challenge, CHALLENGE_LEN, 1, urandom_file)) == 0) {
+	    /* couldn't get a challenge. Fall back to random() and friends.
+	     * notice that even a single changed byte is good enough for us */
+	    have_urandom = NO;
+	    return build_challenge();
+	}
+	return challenge;
+    case NO:
+	if (!(squid_random() % 100)) {	/* sometimes */
+	    init_random();
+	}
+	for (j = 0; j < CHALLENGE_LEN; j++)
+	    challenge[j] = (unsigned char) (squid_random() % 256);
+	return challenge;
+    default:
+	warn("Critical internal error. Somebody forgot to initialize "
+	    "the random system. Exiting.\n");
+	exit(1);
+    }
+}
+
+lstring lmhash, nthash;
+static char have_nthash = 0;	/* simple flag. A tad dirty.. */
+
+void
+do_authenticate(ntlm_authenticate * auth, int auth_length)
+{
+    lstring tmp;
+    int tocopy;
+    NSS_STATUS winbindd_result;
+    struct winbindd_request request;
+    struct winbindd_response response;
+    char *domain, *user;
+
+    memset(&request, 0, sizeof(struct winbindd_request));
+
+    memset(&response, 0, sizeof(struct winbindd_response));
+
+    /* domain */
+    tmp = ntlm_fetch_string((char *) auth, auth_length, &auth->domain);
+    if (tmp.str == NULL || tmp.l == 0) {	/* no domain supplied */
+	request.data.auth_crap.domain[0] = 0;
+    } else {
+	tocopy = min(tmp.l + 1, sizeof(fstring));
+	xstrncpy(request.data.auth_crap.domain, tmp.str, tocopy);
+    }
+
+    domain = request.data.auth_crap.domain;	/* just a shortcut */
+
+    /* username */
+    tmp = ntlm_fetch_string((char *) auth, auth_length, &auth->user);
+    if (tmp.str == NULL || tmp.l == 0) {
+	authfail(domain, "-", "No username in request");
+	return;
+    }
+
+    tocopy = min(sizeof(fstring), tmp.l + 1);
+    xstrncpy(request.data.auth_crap.user, tmp.str, tocopy);
+    user = request.data.auth_crap.user;
+
+    /* now the LM hash */
+    lmhash = ntlm_fetch_string((char *) auth, auth_length, &auth->lmresponse);
+    switch (lmhash.l) {
+    case 0:
+	warn("No lm hash provided by user %s\\%s\n", domain, user);
+	request.data.auth_crap.lm_resp_len = 0;
+	break;
+    case 24:
+	memcpy(request.data.auth_crap.lm_resp, lmhash.str, 24);
+	request.data.auth_crap.lm_resp_len = 24;
+	break;
+    default:
+	authfail(domain, user, "Broken LM hash response");
+	return;
+    }
+
+    nthash = ntlm_fetch_string((char *) auth, auth_length, &auth->ntresponse);
+    switch (nthash.l) {
+    case 0:
+	debug("no nthash\n");
+	request.data.auth_crap.nt_resp_len = 0;
+	break;
+    case 24:
+	memcpy(request.data.auth_crap.nt_resp, nthash.str, 24);
+	request.data.auth_crap.nt_resp_len = 24;
+	break;
+    default:
+	debug("nthash len = %d\n", nthash.l);
+	authfail(domain, user, "Broken NT hash response");
+	return;
+    }
+
+    debug("Checking user '%s\\%s' lmhash len =%d, have_nthash=%d, "
+	"nthash len=%d\n", domain, user, lmhash.l, have_nthash, nthash.l);
+
+    memcpy(request.data.auth_crap.chal, challenge, CHALLENGE_LEN);
+
+    winbindd_result = winbindd_request(WINBINDD_PAM_AUTH_CRAP,
+	&request, &response);
+    debug("winbindd result: %d\n", winbindd_result);
+
+    if (winbindd_result == WINBINDD_OK) {
+	lc(domain);
+	lc(user);
+	authok(domain, user);
+    } else {
+	char error_buf[200];
+	snprintf(error_buf, sizeof(error_buf), "Authentication Failure (%s)",
+	    response.data.auth.error_string);
+	authfail(domain, user, error_buf);
+    }
+    return;			/* useless */
+}
+
+void
+manage_request(char *target_domain)
+{
+    char buf[BUFFER_SIZE + 1];
+    char *c, *decoded;
+    ntlmhdr *fast_header;
+
+
+    if (fgets(buf, BUFFER_SIZE, stdin) == NULL) {
+	warn("fgets() failed! dying..... errno=%d (%s)\n", errno,
+	    strerror(errno));
+	exit(1);		/* BIIG buffer */
+    }
+
+    c = memchr(buf, '\n', BUFFER_SIZE);
+    if (c)
+	*c = '\0';
+    else {
+	warn("No newline in '%s'. Dying.\n", buf);
+	exit(1);
+    }
+
+    debug("Got '%s' from squid.\n", buf);
+    if (memcmp(buf, "YR", 2) == 0) {	/* refresh-request */
+	sendchallenge(ntlm_make_challenge(target_domain, NULL,
+		build_challenge(), CHALLENGE_LEN));
+	return;
+    }
+    if (strncmp(buf, "KK ", 3) != 0) {	/* not an auth-request */
+	helperfail("illegal request received");
+	warn("Illegal request received: '%s'\n", buf);
+	return;
+    }
+    /* At this point I'm sure it's a KK */
+    decoded = base64_decode(buf + 3);
+    if (!decoded) {		/* decoding failure, return error */
+	authfail("-", "-", "Auth-format error, base64-decoding error");
+	return;
+    }
+    fast_header = (struct _ntlmhdr *) decoded;
+
+    /* sanity-check: it IS a NTLMSSP packet, isn't it? */
+    if (memcmp(fast_header->signature, "NTLMSSP", 8) != 0) {
+	authfail("-", "-", "Broken NTLM packet, missing NTLMSSP signature");
+	return;
+    }
+    /* Understand what we got */
+    switch (fast_header->type) {
+    case NTLM_NEGOTIATE:
+	authfail("-", "-", "Received neg-request while expecting auth packet");
+	return;
+    case NTLM_CHALLENGE:
+	authfail("-", "-", "Received challenge. Refusing to abide");
+	return;
+    case NTLM_AUTHENTICATE:
+	do_authenticate((ntlm_authenticate *) decoded,
+	    (strlen(buf) - 3) * 3 / 4);
+	return;
+    default:
+	helperfail("Unknown authentication packet type");
+	return;
+    }
+    /* notreached */
+    return;
+}
+
+static char *
+get_winbind_domain(void)
+{
+    struct winbindd_response response;
+    char *domain;
+
+    ZERO_STRUCT(response);
+
+    /* Send off request */
+
+    if (winbindd_request(WINBINDD_DOMAIN_NAME, NULL, &response) !=
+	NSS_STATUS_SUCCESS) {
+	warn("could not obtain winbind domain name!\n");
+	exit(1);
+    }
+
+    domain = strdup(response.data.domain_name);
+    uc(domain);
+
+    warn("target domain is %s\n", domain);
+    return domain;
+}
+
+char *
+process_options(int argc, char *argv[])
+{
+    int opt;
+    char *target_domain = NULL;
+
+    while (-1 != (opt = getopt(argc, argv, "d"))) {
+	switch (opt) {
+	case 'd':
+	    debug_enabled = 1;
+	    break;
+	default:
+	    warn("Unknown option: -%c. Exiting\n", opt);
+	    exit(1);
+	    break;		/* not reached */
+	}
+	if (optind >= argc - 1) {
+	    target_domain = argv[optind];
+	    warn("target domain is %s\n", target_domain);
+	}
+    }
+    return target_domain;
+}
+
+void
+check_winbindd()
+{
+    NSS_STATUS r;
+    struct winbindd_request request;
+    struct winbindd_response response;
+    r = winbindd_request(WINBINDD_INTERFACE_VERSION, &request, &response);
+    if (r != WINBINDD_OK) {
+	warn("Can't contact winbindd. Dying\n");
+	exit(1);
+    }
+    if (response.data.interface_version != WINBIND_INTERFACE_VERSION) {
+	warn("Winbind protocol mismatch. Align squid and samba. Dying\n");
+	exit(1);
+    }
+}
+
+int
+main(int argc, char **argv)
+{
+    char *target_domain;
+    if (argc > 0) {		/* should always be true */
+	myname = strrchr(argv[0], '/');
+	if (myname == NULL)
+	    myname = argv[0];
+	else
+	    myname++;
+    } else {
+	myname = "(unknown)";
+    }
+    mypid = getpid();
+    target_domain = process_options(argc, argv);
+    debug("ntlm winbindd auth helper build " __DATE__ ", " __TIME__
+	" starting up...\n");
+
+    check_winbindd();
+
+    if (target_domain == NULL) {
+	target_domain = get_winbind_domain();
+    }
+
+    /* initialize FDescs */
+    setbuf(stdout, NULL);
+    setbuf(stderr, NULL);
+    init_random();
+    while (1) {
+	manage_request(target_domain);
+    }
+    return 0;
+}
Index: squid/src/auth/ntlm/helpers/winbind/wbntlm.h
diff -u /dev/null squid/src/auth/ntlm/helpers/winbind/wbntlm.h:1.3.10.1
--- /dev/null	Mon Jan 26 04:57:41 2004
+++ squid/src/auth/ntlm/helpers/winbind/wbntlm.h	Tue Sep  3 10:42:44 2002
@@ -0,0 +1,88 @@
+/*
+ * (C) 2000 Francesco Chemolli <kinkie@kame.usr.dsi.unimi.it>,
+ *
+ * Distributed freely under the terms of the GNU General Public License,
+ * version 2. See the file COPYING for licensing details
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
+ */
+
+#ifndef _WBNTLM_H_
+#define _WBNTLM_H_
+
+#include "config.h"
+#include "ntlmauth.h"
+#include <sys/types.h>
+#include <unistd.h>
+#include <stdlib.h>
+#include <stdio.h>
+
+
+/*************** CONFIGURATION ***************/
+#ifndef DEBUG
+#define DEBUG
+#endif
+
+/* the attempted entropy source. If it doesn't exist, random() is uesed */
+#define ENTROPY_SOURCE "/dev/urandom"
+
+/************* END CONFIGURATION *************/
+
+/* Debugging stuff */
+extern char *myname;
+static char *__foo;
+extern pid_t mypid;
+extern char debug_enabled;
+
+#ifdef DEBUG
+#define __DO_DEBUG 1
+#else
+#define __DO_DEBUG 0
+#endif
+
+#if defined(__GNUC__) || defined(__ICC)    /* this is really a gcc-ism */
+#define warn(X...)  fprintf(stderr,"%s[%d](%s:%d): ", myname, mypid, \
+                    ((__foo=strrchr(__FILE__,'/'))==NULL?__FILE__:__foo+1),\
+                    __LINE__);\
+                    fprintf(stderr,X)
+#define debug(X...) if(__DO_DEBUG && debug_enabled) { warn(X); }
+#else /* __GNUC__ */
+static void
+debug(char *format,...)
+{
+}
+static void
+warn(char *format,...)
+{
+}
+#endif /* __GNUC__ */
+
+
+
+/* A couple of harmless helper macros */
+#define SEND(X) debug("sending '%s' to squid\n",X); printf(X "\n");
+#if defined(__GNUC__) || defined (__ICC)
+#define SEND2(X,Y...) debug("sending '" X "' to squid\n",Y); \
+                      printf(X "\n",Y)
+#else
+/* no gcc, no debugging. varargs macros are a gcc extension */
+#define SEND2 printf
+#endif
+
+typedef enum {
+  YES,
+  NO,
+  DONTKNOW
+} tristate;
+
+#define CHALLENGE_LEN 8
+#define BUFFER_SIZE 2010
+
+#endif /* _WBNTLM_H_ */
Index: squid/src/auth/ntlm/helpers/winbind/winbind_nss_config.h
diff -u /dev/null squid/src/auth/ntlm/helpers/winbind/winbind_nss_config.h:1.3.10.1
--- /dev/null	Mon Jan 26 04:57:41 2004
+++ squid/src/auth/ntlm/helpers/winbind/winbind_nss_config.h	Tue Sep  3 10:42:44 2002
@@ -0,0 +1,148 @@
+/* 
+   Unix SMB/Netbios implementation.
+   Version 2.0
+
+   Winbind daemon for ntdom nss module
+
+   Copyright (C) Tim Potter 2000
+   
+   This library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Library General Public
+   License as published by the Free Software Foundation; either
+   version 2 of the License, or (at your option) any later version.
+   
+   This library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Library General Public License for more details.
+   
+   You should have received a copy of the GNU Library General Public
+   License along with this library; if not, write to the
+   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+   Boston, MA  02111-1307, USA.   
+*/
+
+#ifndef _WINBIND_NSS_CONFIG_H
+#define _WINBIND_NSS_CONFIG_H
+
+/* Include header files from data in config.h file */
+
+#include "config.h"
+
+#include <stdio.h>
+
+#ifdef HAVE_STDLIB_H
+#include <stdlib.h>
+#endif
+
+#ifdef HAVE_UNISTD_H
+#include <unistd.h>
+#endif
+
+#ifdef HAVE_SYS_SOCKET_H
+#include <sys/socket.h>
+#endif
+
+#ifdef HAVE_UNIXSOCKET
+#include <sys/un.h>
+#endif
+
+#ifdef HAVE_SYS_TIME_H
+#include <sys/time.h>
+#endif
+
+#ifdef HAVE_GRP_H
+#include <grp.h>
+#endif
+
+#ifdef HAVE_STRING_H
+#include <string.h>
+#endif
+
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <errno.h>
+#include <pwd.h>
+#include "samba_nss.h"
+
+/* Declarations for functions in winbind_nss.c
+   needed in winbind_nss_solaris.c (solaris wrapper to nss) */
+
+NSS_STATUS _nss_winbind_setpwent(void);
+NSS_STATUS _nss_winbind_endpwent(void);
+NSS_STATUS _nss_winbind_getpwent_r(struct passwd* result, char* buffer,
+				   size_t buflen, int* errnop);
+NSS_STATUS _nss_winbind_getpwuid_r(uid_t, struct passwd*, char* buffer,
+				   size_t buflen, int* errnop);
+NSS_STATUS _nss_winbind_getpwnam_r(const char* name, struct passwd* result,
+				   char* buffer, size_t buflen, int* errnop);
+
+NSS_STATUS _nss_winbind_setgrent(void);
+NSS_STATUS _nss_winbind_endgrent(void);
+NSS_STATUS _nss_winbind_getgrent_r(struct group* result, char* buffer,
+				   size_t buflen, int* errnop);
+NSS_STATUS _nss_winbind_getgrnam_r(const char *name,
+				   struct group *result, char *buffer,
+				   size_t buflen, int *errnop);
+NSS_STATUS _nss_winbind_getgrgid_r(gid_t gid,
+				   struct group *result, char *buffer,
+				   size_t buflen, int *errnop);
+
+/* I'm trying really hard not to include anything from smb.h with the
+   result of some silly looking redeclaration of structures. */
+
+#ifndef _PSTRING
+#define _PSTRING
+#define PSTRING_LEN 1024
+#define FSTRING_LEN 256
+typedef char pstring[PSTRING_LEN];
+typedef char fstring[FSTRING_LEN];
+#endif
+
+#ifndef _BOOL
+#define _BOOL			/* So we don't typedef BOOL again in vfs.h */
+#define False (0)
+#define True (1)
+#define Auto (2)
+typedef int BOOL;
+#endif
+
+#if !defined(uint32)
+#if (SIZEOF_INT == 4)
+#define uint32 unsigned int
+#elif (SIZEOF_LONG == 4)
+#define uint32 unsigned long
+#elif (SIZEOF_SHORT == 4)
+#define uint32 unsigned short
+#endif
+#endif
+
+#if !defined(uint16)
+#if (SIZEOF_SHORT == 4)
+#define uint16 __ERROR___CANNOT_DETERMINE_TYPE_FOR_INT16;
+#else /* SIZEOF_SHORT != 4 */
+#define uint16 unsigned short
+#endif /* SIZEOF_SHORT != 4 */
+#endif
+
+#ifndef uint8
+#define uint8 unsigned char
+#endif
+
+/* zero a structure */
+#define ZERO_STRUCT(x) memset((char *)&(x), 0, sizeof(x))
+
+/* zero a structure given a pointer to the structure */
+#define ZERO_STRUCTP(x) { if ((x) != NULL) memset((char *)(x), 0, sizeof(*(x))); }
+    
+/* Some systems (SCO) treat UNIX domain sockets as FIFOs */
+
+#ifndef S_IFSOCK
+#define S_IFSOCK S_IFIFO
+#endif
+
+#ifndef S_ISSOCK
+#define S_ISSOCK(mode)  ((mode & S_IFSOCK) == S_IFSOCK)
+#endif
+
+#endif
